<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task30.10 Login Form</title>
    <script src="https://code.jquery.com/jquery-3.7.1.js"
        integrity="sha256-eKhayi8LEQwp4NKxN+CfCh+3qOVUtJn3QNZ0TciWLP4=" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.min.js"
        integrity="sha384-+sLIOodYLS7CIrQpBjl+C7nPvqq+FbNUBDunl/OZv93DB7Ln/533i8e/mZXLi/P+"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>
</head>

<body onload="onPageLoading()">
    <div class="container">
        <h1>Login</h1>
        <form id="form-login">
            <div class="form-group">
                <label for="input-email">Email address</label>
                <input type="text" class="form-control" id="input-email" name="username" aria-describedby="emailHelp">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="input-password">Password</label>
                <input type="password" class="form-control" id="input-password" name="password">
            </div>
            <button class="btn btn-primary">Submit</button>
        </form>
    </div>
</body>
<script>

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    function onPageLoading() {
        var loginForm = document.getElementById("form-login");

        loginForm.addEventListener("submit", function (e) {

            e.preventDefault(); // phuong thuc ngan form submit

            console.log("Form duoc submit");

            // Thuc hien 4 buoc xu ly su kien
            var vFormLogin = {
                username: "",
                password: ""
            }
            // B1 : Thu thap du lieu tren form
            thuThapDuLieuDangNhap(vFormLogin);

            // B2 : Kiem tra du lieu tren form
            var vKetQua = kiemTraDuLieuDangNhap(vFormLogin);
            if (vKetQua) {
                // B3 : Goi API
                const vParams = new URLSearchParams(vFormLogin);

                var vXmlHttpLogin = new XMLHttpRequest();
                vXmlHttpLogin.open("GET", gBASE_URL + "?" + vParams.toString(), true);
                vXmlHttpLogin.send();
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  
                            // B4 : Xu ly ket qua tra ve                          
                            xuLyDuLieuDangNhap(vXmlHttpLogin);
                        }else if (this.status == 404){
                            console.log("Sai thong tin dang nhap");
                        }
                    }

            }
        });
    }

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Thu Thap thong tin form login
    function thuThapDuLieuDangNhap(paramFormLogin) {
        var vInputUserName = document.getElementById("input-email");
        var vInputPassword = document.getElementById("input-password");
        paramFormLogin.username = vInputUserName.value.trim();
        paramFormLogin.password = vInputPassword.value.trim();
    }

    // Kiem tra valid du lieu thong tin dang nhap
    // Input : FormObject
    // OUtput : true -> Khi du lieu dam bao dung yeu cau ; false -> DU lieu khong dung yeu cau
    function kiemTraDuLieuDangNhap(paramFormLogin) {
        
        // kiem tra user name khong rong
        if (paramFormLogin.username.length == 0) {
            alert("Ten dang nhap khong duoc rong");
            return false;
        }

        // kiem tra username dung la dia chi email
        if (!validateEmail(paramFormLogin.username)) {
            alert("Username phải có định dạng là email");
            return false;
        }

        // kiem tra password phai khac rong
        if (paramFormLogin.password.length == 0) {
            alert("Password không được rỗng");
            return false;
        }

        return true;
    }

    function xuLyDuLieuDangNhap(paramXmlHttpRequest){
        var vLoginInfo = paramXmlHttpRequest.responseText;
        console.log(vLoginInfo);
    }


    function validateEmail(email) {
        var re = /^(([^<>()\[\]\\\.,;:\s@"]+(\.[^<>()\[\]\\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(String(email).toLowerCase());
    }

</script>

</html>